-- A shrimp-like enemy unit
import "CoreLibs/object"
import "CoreLibs/graphics"
import "CoreLibs/sprites"
import "entity"

local gfx <const> = playdate.graphics
local geom <const> = playdate.geometry

class("Ebi").extends(Entity)

function Ebi:init()
   Ebi.super.init(self, gfx.image.new("images/ebi.png"), 5)
   self:setCollidesWithGroupsMask(0x3)
   self.type = 'ebi'
end

function Ebi:onReady()
   self.weaponTimer = playdate.timer.new(2500,
      function()
         local b = Bullet(2, 1)
         b:moveTo(self.x - (self.width/2) - 1, self.y)
         b:add()
      end
   )
   self.weaponTimer.repeats = true
end

-- Ebi needs to bounce off the walls
function Ebi:runReady()
   local collisions = Ebi.super.runReady(self)
   for i=1, #collisions, 1 do
      if collisions[i].other:getGroupMask() == 0x1 then
         self.vector.dy *= -1
      end
   end
end

function Ebi:remove()
   Ebi.super.remove(self)
   if self.weaponTimer then self.weaponTimer:remove() end
end
